program FAT16Test;

{ $BOOTRST $03800}         {Reset Jump to $03800}
{$W+ Warnings}             {Warnings on}

Device = mega128, VCC = 5;

Define_Fuses
  LockBits0      = [];
  FuseBits0      = [BODEN];
  FuseBits1      = [CKOPT, SPIEN, JTAGEN, OCDEN];
  FuseBits2      = [];
  ProgMode       = JTAG;

Import SysTick, LCDmultiPort, TWImaster;

From System Import LongWord, LongInt, Float, Pipes, PIDs;

Define
  ProcClock      = 16000000;        {Hertz}
  SysTick        = 10;             {msec}
  StackSize      = $0180, iData;
  FrameSize      = $0180, iData;
  TWIpresc       = TWI_BR400;


  LCDmultiPort   = I2C_TWI;
  LCDTYPE_M      = 44780;          // 66712;
  LCDrows_M      = 4;              {4 rows}
  LCDcolumns_M   = 20;             {20 chars per line}

Uses FAT16_Lib;

Implementation

{$IDATA}

{--------------------------------------------------------------}
{ Type Declarations }

type


{--------------------------------------------------------------}
{ Const Declarations }


{--------------------------------------------------------------}
{ Var Declarations }
{$IDATA}
Var
  aa             : longint;
  bb             : word;
  i              : Word;
  ss             : String[12];
  vv             : word;
{--------------------------------------------------------------}
{ functions }



{--------------------------------------------------------------}
{ Main Program }
{$IDATA}

begin
  EnableInts;
  LCDsetup_M(LCD_m1);
  LCDcursor_M(LCD_m1, false, false);
  LCDxy_M(LCD_m1, 0, 0);
  Write(LCDOut_M, '  E-LAB Computers');
  LCDxy_M(LCD_m1, 0, 1);
  Write(LCDOut_M, '   I2C MMC Test');
  mDelay(3000);
  LCDCLR_M(LCD_m1);

  FAT16Lib_SetI2CAddr(15);
  FAT16Lib_Sync;

  If  FAT16Lib_Init = False then
    LCDxy_M(LCD_m1, 0, 0);
    Write(LCDOut_M, 'FAT16 Init: NOT OK');
  else
    LCDxy_M(LCD_m1, 0, 0);
    Write(LCDOut_M, 'FAT16 Init: OK');
  end_if;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  If FAT16Lib_GetDisksize(aa) = False then
    LCDxy_M(LCD_m1, 0, 0);
    Write(LCDOut_M, 'DiskSize: Failed');
  else
    LCDCLR_M(LCD_m1);
    LCDxy_M(LCD_m1, 0, 0);
    Write(LCDOut_M, 'DiskSize:');
    LCDxy_M(LCD_m1, 0, 1);
    Write(LCDOut_M,longtostr(aa));
  end_if;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  LCDxy_M(LCD_m1, 0, 0);
  Write(LCDOut_M, 'Loesche Disk');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_ERASEALL = False then
    Write(LCDOut_M, 'EraseAll: NOT OK');
  else
    Write(LCDOut_M, 'EraseAll: OK');
  end_if;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  LCDxy_M(LCD_m1, 0, 0);
  Write(LCDOut_M, 'Erstelle 3 Verzeich.');
  mDelay(1000);
  For i := 1 to 3 do
    LCDxy_M(LCD_m1, 0, 1);
    If FAT16Lib_CreateDIR('', 'ELAB' + inttostr(i), 123, 123) = False then
      Write(LCDOut_M, 'CreateDir ' + inttostr(i) +  ': NOT OK');
    else
      Write(LCDOut_M, 'CreateDir ' + inttostr(i) +  ': OK');
    end_if;
    mDelay(750);
  end_for;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  LCDxy_M(LCD_m1, 0, 0);
  Write(LCDOut_M, 'Loesche 2 Verzeichn.');
  mDelay(1000);
  For i := 2 to 3 do
    LCDxy_M(LCD_m1, 0, 1);
    If FAT16Lib_EraseDIR('', 'ELAB' + inttostr(i)) = False then
      mDelay(3000);
      Write(LCDOut_M, 'EraseDir ' + inttostr(i) +  ': NOT OK');
      else
      Write(LCDOut_M, 'EraseDir ' + inttostr(i) +  ': OK');
    end_if;
    mDelay(750);
  end_for;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  LCDxy_M(LCD_m1, 0, 0);
  Write(LCDOut_M, 'Erstelle einen File');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_PathExist('ELAB1') then
    Write(LCDOut_M, 'Path: OK');
  else
    Write(LCDOut_M, 'Path: NOT OK');
  endif;

  LCDxy_M(LCD_m1, 0, 2);
  If FAT16Lib_FileCreate('ELAB1', 'TESTFILE.TST', 00, 123, 123, 2000) then
    Write(LCDOut_M, 'File create: OK');
  else
    Write(LCDOut_M, 'File create: NOT OK');
  endif;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'Diskfree:');
    LCDxy_M(LCD_m1, 0, 1);
    If FAT16Lib_GetDiskfree(aa) = False then
      Write(LCDOut_M, 'Diskfree: NOT OK');
    else
      Write(LCDOut_M, longToStr(aa));
    end_if;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'Pruefe File');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_FileExist('ELAB1', 'TESTFILE.TST', 00) then
    Write(LCDOut_M, 'File: OK');
    else
    Write(LCDOut_M, 'File: NOT OK');
  endif;
  mDelay(3000);


//*****************************************************************************
//******** next block because of Bug in Rename ********************************
//*****************************************************************************
// FAT16Lib_Rename with path does not work ==> set default path !!!
// see //** ... in block below

  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'BUG: setze Verzeich.');
  LCDxy_M(LCD_m1, 0, 3);
  Write(LCDOut_M, 'T E M P O R A E R !');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_ChangeDir('ELAB1') then
    Write(LCDOut_M, 'Change Dir: OK');
  else
    Write(LCDOut_M, 'Change Dir: NOT OK');
  endif;
  mDelay(3000);
//*****************************************************************************
//******** END block because of Bug in Rename *********************************
//*****************************************************************************



  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'File umbenennen');
  LCDxy_M(LCD_m1, 0, 3);
  Write(LCDOut_M, 'OHNE PFAD - DA BUG !');
  LCDxy_M(LCD_m1, 0, 1);
  IF FAT16Lib_Rename('', 'TESTFILE.TST', 'RENAMED.CHK')then
//**  IF FAT16Lib_Rename('ELAB1', 'TESTFILE.TST', 'RENAMED.CHK')then  //ERROR !!!
//**  IF FAT16Lib_Rename('\ELAB1', 'TESTFILE.TST', 'RENAMED.CHK')then  //ERROR !!!
//**  IF FAT16Lib_Rename('..\ELAB1', 'TESTFILE.TST', 'RENAMED.CHK')then  //ERROR !!!
//**  UFAT16.pcu returns always NAK !!!
    Write(LCDOut_M, 'Rename: OK');
    else
    Write(LCDOut_M, 'Rename: NOT OK');
  endif;
  mDelay(3000);


//*****************************************************************************
//******** return to Root to continue *****************************************
//*****************************************************************************
// reset to root to continue the tests!!!
  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'END BUG: go to Root');
  LCDxy_M(LCD_m1, 0, 3);
  Write(LCDOut_M, 'T E M P O R A E R !');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_ChangeDir('\') then
    Write(LCDOut_M, 'Change Dir: OK');
  else
    Write(LCDOut_M, 'Change Dir: NOT OK');
  endif;
  mDelay(3000);
//*****************************************************************************
//******** END return to Root to continue *************************************
//*****************************************************************************


  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'Pruefe File');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_FileExist('ELAB1','RENAMED.CHK',00) then
    Write(LCDOut_M, 'File: OK');
  else
    Write(LCDOut_M, 'File: NOT OK');
  endif;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'File kopieren');
  FAT16Lib_Copy('ELAB1', 'RENAMED.CHK', 'ELAB1', 'KOPIE.XYZ');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_FileExist('ELAB1','KOPIE.XYZ',00) then
    Write(LCDOut_M, 'Copy: OK');
  else
    Write(LCDOut_M, 'Copy: NOT OK');
  endif;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'File loeschen');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_FileDelete('ELAB1', 'RENAMED.CHK') then
    Write(LCDOut_M, 'Delete: OK');
  else
    Write(LCDOut_M, 'Delete: NOT OK');
  endif;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'setze Verzeichnis');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_ChangeDir('ELAB1') then
    Write(LCDOut_M, 'Change Dir: OK');
  else
    Write(LCDOut_M, 'Change Dir: NOT OK');
  endif;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'lese akt. Verzeichn.');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_GetDir(ss)then
    Write(LCDOut_M, 'Verz.: '+ ss);
  else
    Write(LCDOut_M, 'Get Dir: NOT OK');
  endif;

  mDelay(3000);
  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'Back to Root');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_ChangeDir('\') then
    Write(LCDOut_M, 'Change Dir: OK');
  else
    Write(LCDOut_M, 'Change Dir: NOT OK');
  endif;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'Assign File');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_AssignFile('ELAB1', 'KOPIE.XYZ', bb) then
    Write(LCDOut_M, 'Assign: OK');
  else
    Write(LCDOut_M, 'Assign: NOT OK');
  endif;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'Pruefe Handle');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_Checkhandle(bb) = True then
    Write(LCDOut_M, 'Check Handle: OK');
    LCDxy_M(LCD_m1, 0, 2);
    Write(LCDOut_M, 'Handle: ' + IntToStr(bb));
  else
    Write(LCDOut_M, 'Check Handle: NOT OK');
  end_If;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'Oeffne File "write"');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_OpenWrite(bb, 1, 2, 2) = True then
    Write(LCDOut_M, 'Open write: OK');
  else
    Write(LCDOut_M, 'Open write: NOT OK');
  end_If;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'Schreibe File');
  LCDxy_M(LCD_m1, 0, 1);
  Write(LCDOut_M, 'OK: .  Fehler: X');
  LCDxy_M(LCD_m1, 0, 2);
  For vv := 0 to 10 do
    IF FAT16Lib_WriteBlock(bb, inttostr(vv : 8) + char(13) + char(27)) = True then
      Write(LCDOut_M, '.');
    else
      Write(LCDOut_M, 'X');
    endif;
    mdelay(500);
  end_For;
  mDelay(3000);

  LCDCLR_M(LCD_m1);
  Write(LCDOut_M, 'Schliesse File');
  LCDxy_M(LCD_m1, 0, 1);
  If FAT16Lib_FileClose(bb) = True then
    Write(LCDOut_M, 'File close: OK');
  else
    Write(LCDOut_M, 'File close: NOT OK');
  end_If;

  LCDxy_M(LCD_m1, 6, 3);
  Write(LCDOut_M, 'E N D E');
  loop
    NOP;
  endloop;
end FAT16Test.

